/*
 * $Id: bgpsim.h,v 1.1.1.1 1998/01/06 20:06:55 labovit Exp $
 */

#ifndef _BGPSIM_H
#define _BGPSIM_H

typedef struct _range_t {
    prefix_t *start;
    prefix_t *end;
} range_t;

typedef struct _network_t {
    int num;
    LINKED_LIST *ll_range;

    u_int stability;		/* interval of up/down in seconds */
    u_int change_interval;	/* interval of change in seconds */
    u_char flag;		/* 1 = up, 0 = down */

    mtimer_t *timer_stability;
    mtimer_t *timer_change;

#define MAX_SETS 100
    int sets[MAX_SETS];
    int max_set;
    int current;		/* current attrib number */

    LINKED_LIST *ll_sets;
} network_t;


typedef struct _simulation_t {
    schedule_t *schedule;
    LINKED_LIST *ll_networks;
    /* LINKED_LIST *ll_aspaths; */

    /* stats */
    u_char on_off;		/* 0 = off */
    time_t time_start;
    u_long packets;

    trace_t *trace;
} simulation_t;

extern simulation_t *SIMULATION;

void network_schedule_stability (mtimer_t * timer, network_t * network);
void network_schedule_change (mtimer_t * timer, network_t * network);

#endif /* _BGPSIM_H */
